<?php declare(strict_types=1);

/*
 *     Pushbullet Notifier [sikofitt/pushbullet-notifier]
 *     Copyright (C) 2017  http://blog.rewiv.com R. Eric Wheeler <sikofitt@gmail.com>
 *
 *     This program is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

namespace Sikofitt\Pushbullet\DependencyInjection;

use Symfony\Component\Config\Definition\Builder\TreeBuilder;
use Symfony\Component\Config\Definition\ConfigurationInterface;

class Configuration implements ConfigurationInterface
{
    /**
     * Generates the configuration tree builder.
     *
     * @throws \RuntimeException
     * @return \Symfony\Component\Config\Definition\Builder\TreeBuilder The
     *   tree builder
     */
    public function getConfigTreeBuilder(): ?TreeBuilder
    {
        $treeBuilder = new TreeBuilder();
        $rootNode = $treeBuilder->root('pushbullet');
        $rootNode
          ->children()
            ->scalarNode('token')
                ->isRequired()
                ->cannotBeEmpty()
            ->end()
            ->arrayNode('push_devices')
                ->cannotBeEmpty()
                ->requiresAtLeastOneElement()
                ->beforeNormalization()
                    ->castToArray()
                ->end()
                ->scalarPrototype()
                ->end()
            ->end()
          ->end();

        return $treeBuilder;
    }
}
